/*	@(#)curses.h 1.8 88/02/08 SMI; from UCB 5.1 85/05/07	*/
#ifndef __CURSES_H
#define __CURSES_H

/*
 * Copyright (c) 1980 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 */
#include <c_varieties.h>

# ifndef WINDOW

# include	<stdio.h>
 
# include	<sgtty.h>

# undef		HZ		/* in case they've included <sys/param.h> */

# define	bool	char
# define	reg	register

# define	TRUE	(1)
# define	FALSE	(0)
# define	ERR	(0)
# define	OK	(1)

# define	_ENDLINE	001
# define	_FULLWIN	002
# define	_SCROLLWIN	004
# define	_FLUSH		010
# define	_FULLLINE	020
# define	_IDLINE		040
# define	_STANDOUT	0200
# define	_NOCHANGE	-1

# define	_puts(s)	tputs(s, 0, _putchar)

typedef	struct sgttyb	SGTTY;

/*
 * Capabilities from termcap
 */

extern bool     AM, BS, CA, DA, DB, EO, HC, HZ, IN, MI, MS, NC, NS, OS, UL,
		XB, XN, XT, XS, XX;
extern char	*AL, *BC, *BT, *CD, *CE, *CL, *CM, *CR, *CS, *DC, *DL,
		*DM, *DO, *ED, *EI, *K0, *K1, *K2, *K3, *K4, *K5, *K6,
		*K7, *K8, *K9, *HO, *IC, *IM, *IP, *KD, *KE, *KH, *KL,
		*KR, *KS, *KU, *LL, *MA, *ND, *NL, *RC, *SC, *SE, *SF,
		*SO, *SR, *TA, *TE, *TI, *UC, *UE, *UP, *US, *VB, *VS,
		*VE, *AL_PARM, *DL_PARM, *UP_PARM, *DOWN_PARM,
		*LEFT_PARM, *RIGHT_PARM;
extern char	PC;

/*
 * From the tty modes...
 */

extern bool	GT, NONL, UPPERCASE, normtty, _pfast;

struct _win_st {
	short		_cury, _curx;
	short		_maxy, _maxx;
	short		_begy, _begx;
	short		_flags;
	short		_ch_off;
	bool		_clear;
	bool		_leave;
	bool		_scroll;
	char		**_y;
	short		*_firstch;
	short		*_lastch;
	struct _win_st	*_nextp, *_orig;
};

# define	WINDOW	struct _win_st

extern bool	My_term, _echoit, _rawmode, _endwin;

extern char	*Def_term, ttytype[50];

extern int	LINES, COLS, _tty_ch, _res_flg;

extern SGTTY	_tty;

extern WINDOW	*stdscr, *curscr;

/*
 *	Define VOID to stop lint from generating "null effect"
 * comments.
 */
# ifdef lint
int	__void__;
# define	VOID(x)	(__void__ = (int) (x))
# else
# define	VOID(x)	(x)
# endif

/*
 * psuedo functions for standard screen
 */
# define	addch(ch)	VOID(waddch(stdscr, ch))
# define	getch()		VOID(wgetch(stdscr))
# define	addstr(str)	VOID(waddstr(stdscr, str))
# define	getstr(str)	VOID(wgetstr(stdscr, str))
# define	move(y, x)	VOID(wmove(stdscr, y, x))
# define	clear()		VOID(wclear(stdscr))
# define	erase()		VOID(werase(stdscr))
# define	clrtobot()	VOID(wclrtobot(stdscr))
# define	clrtoeol()	VOID(wclrtoeol(stdscr))
# define	insertln()	VOID(winsertln(stdscr))
# define	deleteln()	VOID(wdeleteln(stdscr))
# define	refresh()	VOID(wrefresh(stdscr))
# define	inch()		VOID(winch(stdscr))
# define	insch(c)	VOID(winsch(stdscr,c))
# define	delch()		VOID(wdelch(stdscr))
# define	standout()	VOID(wstandout(stdscr))
# define	standend()	VOID(wstandend(stdscr))

/*
 * mv functions
 */
#define	mvwaddch(win,y,x,ch)	VOID(wmove(win,y,x)==ERR?ERR:waddch(win,ch))
#define	mvwgetch(win,y,x)	VOID(wmove(win,y,x)==ERR?ERR:wgetch(win))
#define	mvwaddstr(win,y,x,str)	VOID(wmove(win,y,x)==ERR?ERR:waddstr(win,str))
#define mvwgetstr(win,y,x,str)  VOID(wmove(win,y,x)==ERR?ERR:wgetstr(win,str))
#define	mvwinch(win,y,x)	VOID(wmove(win,y,x) == ERR ? ERR : winch(win))
#define	mvwdelch(win,y,x)	VOID(wmove(win,y,x) == ERR ? ERR : wdelch(win))
#define	mvwinsch(win,y,x,c)	VOID(wmove(win,y,x) == ERR ? ERR:winsch(win,c))
#define	mvaddch(y,x,ch)		mvwaddch(stdscr,y,x,ch)
#define	mvgetch(y,x)		mvwgetch(stdscr,y,x)
#define	mvaddstr(y,x,str)	mvwaddstr(stdscr,y,x,str)
#define mvgetstr(y,x,str)       mvwgetstr(stdscr,y,x,str)
#define	mvinch(y,x)		mvwinch(stdscr,y,x)
#define	mvdelch(y,x)		mvwdelch(stdscr,y,x)
#define	mvinsch(y,x,c)		mvwinsch(stdscr,y,x,c)

/*
 * psuedo functions
 */

#define	clearok(win,bf)	 (win->_clear = bf)
#define	leaveok(win,bf)	 (win->_leave = bf)
#define	scrollok(win,bf) (win->_scroll = bf)
#define flushok(win,bf)	 (bf ? (win->_flags |= _FLUSH):(win->_flags &= ~_FLUSH))
#define	getyx(win,y,x)	 y = win->_cury, x = win->_curx
#define	winch(win)	 (win->_y[win->_cury][win->_curx] & 0177)

#define raw()    (_tty.sg_flags|=RAW, _pfast=_rawmode=TRUE, (void) stty(_tty_ch,&_tty))
#define noraw()  (_tty.sg_flags&=~RAW,_rawmode=FALSE,_pfast=!(_tty.sg_flags&CRMOD), (void) stty(_tty_ch,&_tty))
#define cbreak() (_tty.sg_flags |= CBREAK, _rawmode = TRUE, (void) stty(_tty_ch,&_tty))
#define nocbreak() (_tty.sg_flags &= ~CBREAK,_rawmode=FALSE, (void) stty(_tty_ch,&_tty))
#define crmode() cbreak()	/* backwards compatability */
#define nocrmode() nocbreak()	/* backwards compatability */
#define echo()   (_tty.sg_flags |= ECHO, _echoit = TRUE, (void) stty(_tty_ch, &_tty))
#define noecho() (_tty.sg_flags &= ~ECHO, _echoit = FALSE, (void) stty(_tty_ch, &_tty))
#define nl()     (_tty.sg_flags |= CRMOD,_pfast = _rawmode, (void) stty(_tty_ch, &_tty))
#define nonl()   (_tty.sg_flags &= ~CRMOD, _pfast = TRUE, (void) stty(_tty_ch, &_tty))
#define	savetty() ((void) gtty(_tty_ch, &_tty), _res_flg = _tty.sg_flags)
#define	resetty() (_tty.sg_flags = _res_flg, (void) stty(_tty_ch, &_tty))

#define	erasechar()	(_tty.sg_erase)
#define	killchar()	(_tty.sg_kill)
#define baudrate()	(_tty.sg_ospeed)

EXTERN_FUNCTION ( WINDOW	*initscr,	() );
EXTERN_FUNCTION ( WINDOW	*newwin,	(int, int, int, int) );
EXTERN_FUNCTION ( WINDOW	*subwin,	(WINDOW *, int, int, int, int) );
EXTERN_FUNCTION ( char		*longname,	(char *, char *) );
EXTERN_FUNCTION ( char		*getcap,	(char *) );

/*
 *  Additional decls to please C++.
 */

EXTERN_FUNCTION ( extern int set_term,		(WINDOW *) );
EXTERN_FUNCTION ( extern int keypad,		(WINDOW*, char) );
EXTERN_FUNCTION ( extern int nodelay,		(WINDOW*, char) );
EXTERN_FUNCTION ( extern int intrflush,		(WINDOW*, char) );
EXTERN_FUNCTION ( extern int meta,		(WINDOW*, char) );
EXTERN_FUNCTION ( extern int typeahead,		(int) );
EXTERN_FUNCTION ( extern int doupdate,		() );
EXTERN_FUNCTION ( extern int wnoutrefresh,	(WINDOW *) );
EXTERN_FUNCTION ( extern WINDOW *newpad,	(int, int) );
EXTERN_FUNCTION ( extern void idlok,		(WINDOW*, char) );
EXTERN_FUNCTION ( extern void wattrset,		(WINDOW*, int) );
EXTERN_FUNCTION ( extern int beep,		() );
EXTERN_FUNCTION ( extern int def_prog_mode,	() );
EXTERN_FUNCTION ( extern int def_shell_mode,	() );
EXTERN_FUNCTION ( extern int delay_output,	(int) );
EXTERN_FUNCTION ( extern int fixterm,		() );
EXTERN_FUNCTION ( extern int flash,		() );
EXTERN_FUNCTION ( extern int flushinp,		() );
EXTERN_FUNCTION ( extern int has_ic,		() );
EXTERN_FUNCTION ( extern int has_il,		() );
EXTERN_FUNCTION ( extern int pnoutrefresh,	(WINDOW*, int, int, int, int, int, int) );
EXTERN_FUNCTION ( extern int putp,		(char *) );
EXTERN_FUNCTION ( extern int reset_prog_mode,	() );
EXTERN_FUNCTION ( extern int reset_shell_mode,	() );
EXTERN_FUNCTION ( extern int resetterm,		() );
EXTERN_FUNCTION ( extern int saveterm,		() );
EXTERN_FUNCTION ( extern int setupterm,		(char*, int, int*) );
EXTERN_FUNCTION ( extern int tstp,		() );


EXTERN_FUNCTION ( extern int scroll,		(WINDOW *) );
EXTERN_FUNCTION ( extern int touchwin,		(WINDOW *) );
EXTERN_FUNCTION ( extern int mvwin,		(WINDOW *, int, int) );
EXTERN_FUNCTION ( extern int overlay,		(WINDOW *, WINDOW *) );
EXTERN_FUNCTION ( extern int overwrite,		(WINDOW *, WINDOW *) );
EXTERN_FUNCTION ( extern int wclear,		(WINDOW*) );
EXTERN_FUNCTION ( extern int werase,		(WINDOW*) );
EXTERN_FUNCTION ( extern int wclrtobot,		(WINDOW *) );
EXTERN_FUNCTION ( extern int wclrtoeol,		(WINDOW *) );
EXTERN_FUNCTION ( extern int winsertln,		(WINDOW *) );
EXTERN_FUNCTION ( extern int wmove,		(WINDOW *, int, int) );
EXTERN_FUNCTION ( extern int winsch,		(WINDOW *, char) );
EXTERN_FUNCTION ( extern int wgetstr,		(WINDOW *, char *) );
EXTERN_FUNCTION ( extern int waddch,		(WINDOW *, char) );
EXTERN_FUNCTION ( extern int wgetch,		(WINDOW *) );	/* because it can return KEY_*, for instance. */
EXTERN_FUNCTION ( extern int waddstr,		(WINDOW *, char *) );
EXTERN_FUNCTION ( extern int wdelch,		(WINDOW *) );
EXTERN_FUNCTION ( extern int wdeleteln,		(WINDOW *) );
EXTERN_FUNCTION ( extern int delwin,		(WINDOW *) );
EXTERN_FUNCTION ( extern void idlok,		(WINDOW *, char) );
EXTERN_FUNCTION ( extern void wrefresh,		(WINDOW *) );
EXTERN_FUNCTION ( extern void endwin,		() );

EXTERN_FUNCTION ( extern int box,		(WINDOW*, char, char) );
EXTERN_FUNCTION ( extern int gettmode,		() );
EXTERN_FUNCTION ( extern int mvcur,		(int, int, int, int) );
EXTERN_FUNCTION ( extern int mvprintw,		(int, int, char*, ...) );
EXTERN_FUNCTION ( extern int mvscanw,		(int, int, char*, ...) );
EXTERN_FUNCTION ( extern int mvwprintw,		(WINDOW*, int, int, char*, ...) );
EXTERN_FUNCTION ( extern int mvwscanw,		(WINDOW*, int, int, char*, ...) );
EXTERN_FUNCTION ( extern int printw,		(char*, ...) );
EXTERN_FUNCTION ( extern int scanw,		(char*, ...) );
EXTERN_FUNCTION ( extern int setterm,		(char) );
EXTERN_FUNCTION ( extern int tgetent,		(char*, const char*) );
EXTERN_FUNCTION ( extern int tgetflag,		(const char*) );
EXTERN_FUNCTION ( extern int tgetnum,		(const char*) );
EXTERN_FUNCTION ( extern char *tgetstr,		(const char*, char**) );
EXTERN_FUNCTION ( extern char *tgoto,		(const char*, int, int) );
EXTERN_FUNCTION ( extern char *tparm,		(char*, int, ...) );
EXTERN_FUNCTION ( extern int   tputs,		(const char*, int, int(*)(char)) );
EXTERN_FUNCTION ( extern int   traceoff,	() );
EXTERN_FUNCTION ( extern int   traceon,		() );
EXTERN_FUNCTION ( extern int   vidattr,		(int) );
EXTERN_FUNCTION ( extern int   vidputs,		(int, _PFI_) );
EXTERN_FUNCTION ( extern int wattroff,		(WINDOW*, int) );
EXTERN_FUNCTION ( extern int wattron,		(WINDOW*, int) );
EXTERN_FUNCTION ( extern int wprintw,		(WINDOW*, char*, ...) );
EXTERN_FUNCTION ( extern int wscanw,		(WINDOW*, char*, ...) );
EXTERN_FUNCTION ( extern int wstandend,		(WINDOW*) );
EXTERN_FUNCTION ( extern int wstandout,		(WINDOW*) ); 
EXTERN_FUNCTION ( extern char	*cuserid,	(char *) );

/*
 * Used to be in unctrl.h.
 */
#define	unctrl(c)	_unctrl[(c) & 0177]
extern char *_unctrl[];
# endif

#endif
