/*	@(#)dirent.h 1.7 89/06/25 SMI 	*/

/*
 * Filesystem-independent directory information.
 */

#ifndef	__dirent_h
#define	__dirent_h

#include <sys/types.h>
#include <c_varieties.h>

#ifndef	_POSIX_SOURCE
#define	d_ino	d_fileno	/* compatability */
#ifndef	NULL
#define	NULL	0
#endif
#endif	/* !_POSIX_SOURCE */

/*
 * Definitions for library routines operating on directories.
 */
typedef	struct __dirdesc {
	int	dd_fd;		/* file descriptor */
	long	dd_loc;		/* buf offset of entry from last readddir() */
	long	dd_size;	/* amount of valid data in buffer */
	long	dd_bsize;	/* amount of entries read at a time */
	long	dd_off;		/* Current offset in dir (for telldir) */
	char	*dd_buf;	/* directory data buffer */
} DIR;

EXTERN_FUNCTION( extern	DIR *opendir,		( char *));
EXTERN_FUNCTION( extern	struct dirent *readdir, ( DIR *));
EXTERN_FUNCTION( extern	int closedir,		( DIR *));
#ifndef	_POSIX_SOURCE
EXTERN_FUNCTION( extern	void seekdir,		( DIR *, long ));
EXTERN_FUNCTION( extern	long telldir,		( DIR *));
#endif	/* POSIX_SOURCE */
EXTERN_FUNCTION( extern	void rewinddir,		( DIR *));

#ifndef	lint
#define	rewinddir(dirp)	seekdir((dirp), (long)0)
#endif

#include <sys/dirent.h>

#endif	/* !__dirent_h */
