/* @(#)exportent.h 1.5 88/02/07 (C) 1986 SMI */
#ifndef _exportent_h
#define _exportent_h

#include <c_varieties.h>
/*
 * Exported file system table, see exportent(3)
 * Copyright (C) 1986 by Sun Microsystems, Inc.
 */ 

#define TABFILE "/etc/xtab"		/* where the table is kept */

/*
 * Options keywords
 */
#define ACCESS_OPT	"access"	/* machines that can mount fs */
#define ROOT_OPT	"root"		/* machines with root access of fs */
#define RO_OPT		"ro"		/* export read-only */
#define RW_OPT		"rw"		/* export read-mostly */
#define ANON_OPT	"anon"		/* uid for anonymous requests */
#define SECURE_OPT	"secure"	/* require secure NFS for access */
#define WINDOW_OPT	"window"	/* expiration window for credential */

struct exportent {
	char *xent_dirname;	/* directory (or file) to export */
	char *xent_options;	/* options, as above */
};

EXTERN_FUNCTION ( extern FILE *setexportent,	() );
EXTERN_FUNCTION ( extern void endexportent,	(FILE *) );
EXTERN_FUNCTION ( extern int remexportent,	(FILE *, char *) );
EXTERN_FUNCTION ( extern int addexportent,	(FILE *, char *, char *) );
EXTERN_FUNCTION ( extern char *getexportopt,	(struct exportent *, char *) );
EXTERN_FUNCTION ( extern struct exportent *getexportent,	(FILE *) );

#endif

