/*      @(#)hsfs_private.h 1.2 89/07/29 SMI */

#ifndef _hsfs_hsfs_private_h
#define _hsfs_hsfs_private_h


/*
 * Private definitions for High Sierra filesystem
 * Copyright (c) 1989 by Sun Microsystem, Inc.
 */
#include <c_varieties.h>
/*
 * global routines.
 */
EXTERN_FUNCTION(extern int hs_readsector,		(struct vnode *,u_int,u_char *));
					/* read a sector */

EXTERN_FUNCTION(extern struct vnode *hs_makenode,	(struct hs_direntry *,u_int,
							 u_int,struct vfs *));
					/* lookup/construct an hsnode/vnode */
EXTERN_FUNCTION(extern int hs_remakenode,		(u_int,u_int,struct vfs *,
								struct vnode **));
					/* make hsnode from directory lbn/off */
EXTERN_FUNCTION(extern int hs_dirlook,			(struct vnode *,char *, int,
							struct vnode **, struct ucred *));					/* lookup name in directory */

EXTERN_FUNCTION(extern struct vnode *hs_findhash,	(u_int, struct vfs *));	/* find an hsnode in the hash list */
EXTERN_FUNCTION(extern void hs_freenode,		(struct hsnode *,struct vfs *,
								int));		/* destroy an hsnode */
EXTERN_FUNCTION(extern void hs_freehstbl,		(struct vfs *));
					/* destroy the incore hnode table */

EXTERN_FUNCTION(extern int hs_parsedir,			(struct hsfs *, u_char *,
							struct hs_direntry *,char *,int *));		/* parse a directory entry */
EXTERN_FUNCTION(extern int hs_namecopy,			(enum hs_vol_type,char *,char *,int));		
					/* convert d-characters */
EXTERN_FUNCTION(extern void hs_filldirent,		(struct vnode *, struct hs_direntry *));		
				/* destroy the incore hnode table */

EXTERN_FUNCTION(extern int hs_access,			(struct vnode *, int, struct
								ucred *));
			 
	/* check vnode protection */
EXTERN_FUNCTION(extern int hs_read,			(struct vnode *, struct uio*,
							int, struct ucred *));
					/* vnode read routine */

EXTERN_FUNCTION(extern void hs_synchash,		(struct vfs *));

#define UCRED			u.u_cred

#endif  /* !_hsfs_hsfs_private_h */
