/*	@(#)math.h 1.30 89/07/20 SMI	*/

/*
 * Copyright (c) 1988 by Sun Microsystems, Inc.
 */

/*
 * Math library definitions for all the public functions implemented in libm.a.
 */

#ifndef	__math_h
#define	__math_h

#include <c_varieties.h>
#include <stdio.h>

/*
 * Posix (actually ansi C) section
 */
#define	HUGE_VAL	(__infinity())	/* Produces IEEE Infinity. */


EXTERN_FUNCTION( extern double	__infinity,		(_VOID_));
EXTERN_FUNCTION( extern double	acos,			( double ));
EXTERN_FUNCTION( extern double	asin,			( double ));
EXTERN_FUNCTION( extern double	atan,			( double ));
EXTERN_FUNCTION( extern double	atan2,			( double , double ));
EXTERN_FUNCTION( extern double	ceil,			( double ));
EXTERN_FUNCTION( extern double	cos,			( double ));
EXTERN_FUNCTION( extern double	cosh,			( double ));
EXTERN_FUNCTION( extern double	exp,			( double ));
EXTERN_FUNCTION( extern double	fabs,			( double ));
EXTERN_FUNCTION( extern double	floor,			( double ));
EXTERN_FUNCTION( extern double	fmod,			( double , double ));
EXTERN_FUNCTION( extern double	frexp,			( double , int *));
EXTERN_FUNCTION( extern double	ldexp,			( double , int ));
EXTERN_FUNCTION( extern double	log,			( double ));
EXTERN_FUNCTION( extern double	log10,			( double ));
EXTERN_FUNCTION( extern double	modf,			( double , double *));
EXTERN_FUNCTION( extern double	pow,			( double , double ));
EXTERN_FUNCTION( extern double	sin,			( double ));
EXTERN_FUNCTION( extern double	sinh,			( double ));
EXTERN_FUNCTION( extern double	sqrt,			( double ));
EXTERN_FUNCTION( extern double	tan,			( double ));
EXTERN_FUNCTION( extern double	tanh,			( double ));
#ifndef	_POSIX_SOURCE			/* the rest of the file is !POSIX */
#include <floatingpoint.h>		/* Contains definitions for types and
					 * functions implemented in libc.a.
					 */
EXTERN_FUNCTION( extern double	acosh,			(double));
EXTERN_FUNCTION( extern double	asinh,			(double));
EXTERN_FUNCTION( extern double	atanh,			(double));
EXTERN_FUNCTION( extern double	cbrt,			(double));
EXTERN_FUNCTION( extern double	copysign,		(double,double));
EXTERN_FUNCTION( extern double	erf,			(double));
EXTERN_FUNCTION( extern double	erfc,			(double));
EXTERN_FUNCTION( extern double	expm1,			(double));
EXTERN_FUNCTION( extern int	finite,			(double));
EXTERN_FUNCTION( extern double	hypot,			(double,double));
EXTERN_FUNCTION( extern double	j0,			(double));
EXTERN_FUNCTION( extern double	j1,			(double));
EXTERN_FUNCTION( extern double	jn,			(double));
EXTERN_FUNCTION( extern double	lgamma,			(double));
EXTERN_FUNCTION( extern double	log1p,			(double));
EXTERN_FUNCTION( extern double	rint,			(double));
EXTERN_FUNCTION( extern double	y0,			(double));
EXTERN_FUNCTION( extern double	y1,			(double));
EXTERN_FUNCTION( extern double	yn,			(double));
/*
 * Sun definitions.
 */

/*
 * Implemented precisions for trigonometric argument reduction.
 */
enum fp_pi_type {
	fp_pi_infinite	= 0,	/* Infinite-precision approximation to pi. */
	fp_pi_66	= 1,	/* 66-bit approximation to pi. */
	fp_pi_53	= 2	/* 53-bit approximation to pi. */
};

/*
 * Pi precision to use for trigonometric argument reduction.
 */
extern enum	fp_pi_type fp_pi;

/*
 * Functions callable from C, intended to support IEEE arithmetic.
 */
EXTERN_FUNCTION( extern enum	fp_class_type fp_class,	(double));
EXTERN_FUNCTION( extern int	ieee_flags,		(char *,char *,char *,char **));
EXTERN_FUNCTION( extern int	ieee_handler,		(char *,char *,sigfpe_handler_type));
EXTERN_FUNCTION( extern void	ieee_retrospective,	(FILE *));
EXTERN_FUNCTION( extern int	ilogb,			(double));
EXTERN_FUNCTION( extern double	infinity,		());
EXTERN_FUNCTION( extern int	irint,			(double));
EXTERN_FUNCTION( extern int	isinf,			(double));
EXTERN_FUNCTION( extern int	isnan,			(double));
EXTERN_FUNCTION( extern int	isnormal,		(double));
EXTERN_FUNCTION( extern int	issubnormal,		(double));
EXTERN_FUNCTION( extern int	iszero,			(double));
EXTERN_FUNCTION( extern double	logb,			(double));
EXTERN_FUNCTION( extern double	max_normal,		(_VOID_));
EXTERN_FUNCTION( extern double	max_subnormal,		(_VOID_));
EXTERN_FUNCTION( extern double	min_normal,		(_VOID_));
EXTERN_FUNCTION( extern double	min_subnormal,		(_VOID_));
EXTERN_FUNCTION( extern double	nextafter,		(double,double));
EXTERN_FUNCTION( extern void	nonstandard_arithmetic,	(_VOID_));
EXTERN_FUNCTION( extern double	quiet_nan,		(long));
EXTERN_FUNCTION( extern double	remainder,		(double,double));
EXTERN_FUNCTION( extern double	scalb,			(double,double));
EXTERN_FUNCTION( extern double	scalbn,			(double,int));
EXTERN_FUNCTION( extern double	signaling_nan,		(long));
EXTERN_FUNCTION( extern int	signbit,		(double));
EXTERN_FUNCTION( extern double	significant,		(double));
EXTERN_FUNCTION( extern void	standard_arithmetic,	(_VOID_));
/*
 * Other functions for C programmers.
 */
EXTERN_FUNCTION( extern double	acospi,			(double));
EXTERN_FUNCTION( extern double	aint,			(double));
EXTERN_FUNCTION( extern double	anint,			(double));
EXTERN_FUNCTION( extern double	annuity,		(double,double));
EXTERN_FUNCTION( extern double	asinpi,			(double));
EXTERN_FUNCTION( extern double	atan2pi,		(double,double));
EXTERN_FUNCTION( extern double	atanpi,			(double));
EXTERN_FUNCTION( extern double	compound,		(double,double));
EXTERN_FUNCTION( extern double	cospi,			(double));
EXTERN_FUNCTION( extern double	exp10,			(double));
EXTERN_FUNCTION( extern double	exp2,			(double));
EXTERN_FUNCTION( extern double	log2,			(double));
EXTERN_FUNCTION( extern int	nint,			(double));
EXTERN_FUNCTION( extern void	sincos,			(double,double *,double *));
EXTERN_FUNCTION( extern void	sincospi,		(double,double *,double *));
EXTERN_FUNCTION( extern double	sinpi,			(double));
EXTERN_FUNCTION( extern double	tanpi,			(double));
EXTERN_FUNCTION( extern int	matherr,		(struct exception *));

/*
 *	Single-precision functions callable from Fortran, Pascal, Modula-2, etc,
 *	take float* arguments instead of double and
 *	return FLOATFUNCTIONTYPE results instead of double.
 *	RETURNFLOAT is used to return a float function value without conversion
 *	to double.
 *	ASSIGNFLOAT is used to get the float value out of a FLOATFUNCTIONTYPE
 *	result.
 *	We don't want you to have to think about -fsingle2.
 *
 *	Some internal library functions pass float parameters as 32-bit values,
 *	disguised as FLOATPARAMETER.  FLOATPARAMETERVALUE(x) extracts the
 *	float value from the FLOATPARAMETER.
 */

/*	mc68000 returns float results in d0, same as int	*/

#ifdef	mc68000
#define	FLOATFUNCTIONTYPE	int
#define	RETURNFLOAT(x) 		return (*(int *)(&(x)))
#define	ASSIGNFLOAT(x,y)	*(int *)(&x) = y
#endif

/*	sparc returns float results in %f0, same as top half of double	*/

#ifdef	sparc
#define	FLOATFUNCTIONTYPE	double
#define	RETURNFLOAT(x) 		{ union {double _d; float _f } _kluge; _kluge._f = (x); return _kluge._d; }
#define	ASSIGNFLOAT(x,y)	{ union {double _d; float _f } _kluge; _kluge._d = (y); x = _kluge._f; }
#endif

/*	i386 returns float results on stack as extendeds, same as double */

#ifdef	i386
#define	FLOATFUNCTIONTYPE	float
#define	RETURNFLOAT(x) 		return (x)
#define	ASSIGNFLOAT(x,y)	x = y
#endif

/* So far everybody passes float parameters as 32 bits on stack, same as int. */

#define	FLOATPARAMETER		int
#define	FLOATPARAMETERVALUE(x)	(*(float *)(&(x)))

EXTERN_FUNCTION( extern int		 ir_finite_,		(float *));
EXTERN_FUNCTION( extern enum fp_class_type ir_fp_class_,	(float *));
EXTERN_FUNCTION( extern int		 ir_ilogb_,		(float *));
EXTERN_FUNCTION( extern int		 ir_irint_,		(float *));
EXTERN_FUNCTION( extern int		 ir_isinf_,		(float *));
EXTERN_FUNCTION( extern int		 ir_isnan_,		(float *));
EXTERN_FUNCTION( extern int		 ir_isnormal_,		(float *));
EXTERN_FUNCTION( extern int		 ir_issubnormal_,	(float *));
EXTERN_FUNCTION( extern int		 ir_iszero_,		(float *));
EXTERN_FUNCTION( extern int		 ir_nint_,		(float *));
EXTERN_FUNCTION( extern int		 ir_signbit_,		(float *));
EXTERN_FUNCTION( extern void		 r_sincos_,		(float *,float *,float *));
EXTERN_FUNCTION( extern void		 r_sincospi_,		(float *,float *,float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_acos_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_acosh_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_acospi_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_aint_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_anint_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_annuity_,		(float *,float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_asin_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_asinh_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_asinpi_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_atan2_,		(float *,float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_atan2pi_,		(float *,float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_atan_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_atanh_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_atanpi_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_cbrt_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_ceil_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_compound_,		(float *,float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_copysign_,		(float *,float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_cos_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_cosh_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_cospi_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_erf_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_erfc_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_exp10_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_exp2_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_exp_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_expm1_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_fabs_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_floor_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_fmod_,		(float *,float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_hypot_,		(float *,float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_infinity_,		());
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_j0_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_j1_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_jn_,		(int *,float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_lgamma_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_log10_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_log1p_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_log2_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_log_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_logb_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_max_normal_,	());
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_max_subnormal_,	());
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_min_normal_,	());
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_min_subnormal_,	());
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_nextafter_,		(float *,float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_pow_,		(float *,float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_quiet_nan_,		(int *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_remainder_,		(float *,float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_rint_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_scalb_,		(float *,float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_scalbn_,		(float *,int *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_signaling_nan_,	(int *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_significand_,	(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_sin_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_sinh_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_sinpi_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_sqrt_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_tan_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_tanh_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_tanpi_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_y0_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_y1_,		(float *));
EXTERN_FUNCTION( extern FLOATFUNCTIONTYPE r_yn_,		(int *,float *));

/* 	Constants, variables, and functions from System V */

#define	_ABS(x) ((x) < 0 ? -(x) : (x))

#define	HUGE		(infinity())	/* For historical compatibility. */

#define	DOMAIN		1
#define	SING		2
#define	OVERFLOW	3
#define	UNDERFLOW	4
#define	TLOSS		5
#define	PLOSS		6

struct exception {
	int type;
	char *name;
	double arg1;
	double arg2;
	double retval;
};

/*
 * First three have to be defined exactly as in values.h including spacing!
 */
#define	M_LN2	0.69314718055994530942
#define	M_PI	3.14159265358979323846
#define	M_SQRT2	1.41421356237309504880

#define	M_E		2.7182818284590452354
#define	M_LOG2E		1.4426950408889634074
#define	M_LOG10E	0.43429448190325182765
#define	M_LN10		2.30258509299404568402
#define	M_PI_2		1.57079632679489661923
#define	M_PI_4		0.78539816339744830962
#define	M_1_PI		0.31830988618379067154
#define	M_2_PI		0.63661977236758134308
#define	M_2_SQRTPI	1.12837916709551257390
#define	M_SQRT1_2	0.70710678118654752440
#define	_REDUCE(TYPE, X, XN, C1, C2)	{ \
	double x1 = (double)(TYPE)X, x2 = X - x1; \
	X = x1 - (XN) * (C1); X += x2; X -= (XN) * (C2); }
#define	_POLY1(x, c)    ((c)[0] * (x) + (c)[1])
#define	_POLY2(x, c)    (_POLY1((x), (c)) * (x) + (c)[2])
#define	_POLY3(x, c)    (_POLY2((x), (c)) * (x) + (c)[3])
#define	_POLY4(x, c)    (_POLY3((x), (c)) * (x) + (c)[4])
#define	_POLY5(x, c)    (_POLY4((x), (c)) * (x) + (c)[5])
#define	_POLY6(x, c)    (_POLY5((x), (c)) * (x) + (c)[6])
#define	_POLY7(x, c)    (_POLY6((x), (c)) * (x) + (c)[7])
#define	_POLY8(x, c)    (_POLY7((x), (c)) * (x) + (c)[8])
#define	_POLY9(x, c)    (_POLY8((x), (c)) * (x) + (c)[9])

extern int	signgam;
/*
 *	Deprecated functions for compatibility with past.
 *	Changes planned for future.
 */

EXTERN_FUNCTION( extern double cabs,		(DOTDOTDOT));	
			/* Use double hypot(x,y)
			 * Traditional cabs usage is confused -
			 * is its argument two doubles or one struct?
			 */
EXTERN_FUNCTION( extern double drem,		(double,double));
			/* Use double remainder(x,y)
			 * drem will disappear in a future release.
			 */
EXTERN_FUNCTION( extern double gamma,		(double));	
			/* Use double lgamma(x)
			 * to compute log of gamma function.
			 * Name gamma is reserved for true gamma function
			 * to appear in a future release.
			 */
#endif	/* !_POSIX_SOURCE */


/*	
 *	This is extracted from AT&T's math.h.
 * ident "@(#)C++env:incl-master/proto-headers/math.h    1.2"
 *
 * MATH_H_INLINE has to be defined in order to use the
 * following functions to avoid confusion with 'abs' in 
 * other libraries.
 */

#ifdef MATH_H_INLINE

inline int sqr(int x) {return(x*x);}
inline double sqr(double x) {return(x*x);}
 
inline int abs(int d) { return (d>0)?d:-d; }
inline double abs(double d) { return fabs(d); }

#endif

#endif	/* !__math_h */
