/* @(#)cg4var.h 1.7 88/02/08 SMI */

/*
 * Copyright 1986 by Sun Microsystems, Inc.
 */
#include <c_varieties.h>

#ifndef	cg4var_DEFINED
#define	cg4var_DEFINED

/*
 * cg4 -- color memory frame buffer
 */

/* FBIOSATTR device specific array indices */
#define FB_ATTR_CG4_SETOWNER_CMD	0	/* 1 indicates PID is valid */
#define	FB_ATTR_CG4_SETOWNER_PID	1	/* new owner of device */

#include <pixrect/memvar.h>

#define	CG4_NFBS	3	/* number of frame buffers in a cg4 */

/* description of single frame buffer */
struct cg4fb {
	short			group;		/* plane group implemented */
	short			depth;		/* depth, bits */
	struct mprp_data	mprp;		/* memory pixrect data */
};
	
/* pixrect private data */
struct cg4_data {
	struct mprp_data	mprp;		/* memory pixrect simulator */
	int			flags;		/* misc. flags */
#define	CG4_PRIMARY		1		/* primary pixrect */
#define	CG4_OVERLAY_CMAP	2		/* overlay has colormap */
	int			planes;		/* current group and mask */
	int			fd;		/* file descriptor */
	short			active;		/* active fb no. */
	struct cg4fb		fb[CG4_NFBS];	/* frame buffer info */
};

/* useful macros */
#define	cg4_d(pr)	((struct cg4_data *) ((pr)->pr_data))

/* pixrect ops vector */
extern struct pixrectops cg4_ops;

EXTERN_FUNCTION ( int	cg4_putcolormap,	(Pixrect *, int, int, unsigned char *, unsigned char *, 
						 unsigned char *) );
EXTERN_FUNCTION ( int	cg4_putattributes,	(Pixrect *, int *) );
#include <sys/types.h>

EXTERN_FUNCTION ( int cg4_ioctl,	(Pixrect *,int,caddr_t));

#ifndef KERNEL
EXTERN_FUNCTION ( Pixrect	*cg4_make,	(int, int, struct pr_size) );
EXTERN_FUNCTION ( int	cg4_destroy,		(Pixrect *) );
EXTERN_FUNCTION ( Pixrect *cg4_region,		(Pixrect *, int, int, int, int) );
EXTERN_FUNCTION ( int	cg4_getcolormap,	(Pixrect *, int, int, unsigned char *, unsigned char *,
						 unsigned char *) );
EXTERN_FUNCTION ( int	cg4_getattributes,	(Pixrect *, int *) );
#endif !KERNEL

#endif	!cg4var_DEFINED
