/*      @(#)pr_io.h 1.4 89/09/18 SMI	*/

/*
 * Copyright (c) 1989 by Sun Microsystems, Inc.
 */
#include <c_varieties.h>
#ifndef FILE
#include <stdio.h>
#endif

#ifndef pr_io_DEFINED
#define pr_io_DEFINED

/*
 * Data definitions and constant definitions for clients of utilities
 *   to do i/o between pixrects and rasterfiles.
 *
 */

typedef struct {
	int		 type;
	int		 length;
	unsigned char 	*map[3];
} colormap_t;
/*
 * The type should be one of the supported ras_maptype's in rasterfile.h.
 * Note: the interpretation of the length and map array depends on the type.
 */


/* error messages */
#define PR_IO_ERR_BADDEPTH	"Cannot replicate color pixrect if depth != 8"
#define PR_IO_ERR_CDEPTH	\
			"Color raster depth does not match display depth"
#define PR_IO_ERR_DISPLAY	"Cannot open display device"
#define PR_IO_ERR_INFILE	"Cannot open input file"
#define PR_IO_ERR_NOBWDISPLAY	\
			"Cannot open display device for monochrome raster"
#define PR_IO_ERR_NOCDISPLAY	"Cannot open display device for color raster"
#define PR_IO_ERR_NONULL	"Cannot process null argument"
#define PR_IO_ERR_OUTFILE	"Cannot open output file"
#define PR_IO_ERR_PIXRECT	"Internal pixrect operation failed"
#define PR_IO_ERR_RASREAD	"Error reading rasterfile input data"
#define PR_IO_ERR_RASREADH	"Error reading rasterfile header"
#define PR_IO_ERR_RASWRITE	"Error writing rasterfile output data"
#define PR_IO_ERR_RASWRITEH	"Error writing rasterfile header"

/* declarations */
EXTERN_FUNCTION ( extern int pr_dump,			(Pixrect *, FILE *, colormap_t *, int, int) );
EXTERN_FUNCTION ( extern int pr_dump_header,		(FILE *, struct rasterfile *, colormap_t *) );
EXTERN_FUNCTION ( extern int pr_dump_image,		(Pixrect *, FILE *, struct rasterfile *) );
EXTERN_FUNCTION ( extern Pixrect * pr_dump_init,	(Pixrect *, struct rasterfile *, colormap_t *,
							 int, int) );
EXTERN_FUNCTION ( extern Pixrect * pr_load,		(FILE *, colormap_t *) );
EXTERN_FUNCTION ( extern int pr_load_colormap,		(FILE *, struct rasterfile *, colormap_t *) );
EXTERN_FUNCTION ( extern int pr_load_header,		(FILE *, struct rasterfile *) );
EXTERN_FUNCTION ( extern Pixrect * pr_load_image,	(FILE *, struct rasterfile *, colormap_t *) );
EXTERN_FUNCTION ( extern Pixrect * pr_load_std_image,	(FILE *, struct rasterfile *, colormap_t *) );

#endif pr_io_DEFINED
