/*	@(#)pr_planegroups.h 1.10 90/05/28 SMI	*/

/*
 * Copyright 1986 by Sun Microsystems, Inc.
 */
#include <c_varieties.h>

#ifndef	pr_planegroups_DEFINED
#define	pr_planegroups_DEFINED

/* Masks for frame buffer planes and plane group number */
#define	PIX_ALL_PLANES		0x00FFFFFF
#define	PIX_GROUP_MASK		0x7F

/* Macros to encode or extract group into or from attribute word */
#define	PIX_GROUP(g)		((g) << 25)
#define	PIX_ATTRGROUP(attr)	((unsigned)(attr) >> 25)

/* Flag bit which inhibits plane mask setting (for setting group only) */
#define	PIX_DONT_SET_PLANES	(1 << 24)
 
/*  Plane groups definitions */
/* !!! NOTE: Be sure to increment LAST_PLUS_ONE as new groups are added !!! */

#define	PIXPG_CURRENT		0
#define PIXPG_MONO		1
#define PIXPG_8BIT_COLOR	2
#define PIXPG_OVERLAY_ENABLE	3
#define PIXPG_OVERLAY	 	4
#define PIXPG_24BIT_COLOR	5
#define PIXPG_VIDEO		6
#define PIXPG_VIDEO_ENABLE	7
#define PIXPG_TRANSPARENT_OVERLAY	8
#define PIXPG_WID		9	/* Window Id */
#define PIXPG_ZBUF		10	/* Z (depth) buffer */
#define	PIXPG_LAST_PLUS_ONE	11	/* array decls and loop termination */
#define	PIXPG_INVALID		127

#define MAKEPLNGRP(pg) (1 << (pg))

/* Plane groups functions */
EXTERN_FUNCTION ( extern int pr_available_plane_groups,	(Pixrect *, int, char *) );
EXTERN_FUNCTION ( extern int pr_get_plane_group,	(Pixrect *) );
EXTERN_FUNCTION ( extern void pr_set_plane_group,	(Pixrect *, int) );
EXTERN_FUNCTION ( extern void pr_set_planes,		(Pixrect *, int, int) );

#endif	pr_planegroups_DEFINED
