/*	@(#)rfs_xdr.h 1.5 88/09/14 SMI 	*/

/*
 * XDR related stuff for kernel
 */

#ifndef _rfs_rfs_xdr_h
#define _rfs_rfs_xdr_h

#include <c_varieties.h>
/*
 * Macros to call XDR conversion routines. The first argument is the
 * name of the data structure (defined below) to be converted. This
 * is concatenated with the common prefix "xdrwrap_" to generate the
 * the name of the XDR conversion routine.
 */
#define tcanon(xdrproc,from,to)  xdrwrap_/**/xdrproc(from,to,XDR_ENCODE)
#define fcanon(xdrproc,from,to)  xdrwrap_/**/xdrproc(from,to,XDR_DECODE)

/* RFS data types sizes for XDRizing -- these are the canonical sizes.  */
#define XR_LOCK		48
#define XR_STAT		88
#define XR_STATFS	52
#define XR_USTAT	32
#define XR_UTIMBUF	 8
#define XR_MESSAGE	32
#define XR_REQ		80


EXTERN_FUNCTION( extern bool_t xdr_rfs_flock,		(XDR *, rfs_flock *));
EXTERN_FUNCTION( extern bool_t xdr_rfs_stat,		(XDR *, rfs_stat *));
EXTERN_FUNCTION( extern bool_t xdr_rfs_statfs,		(XDR *, rfs_statfs *));
EXTERN_FUNCTION( extern bool_t xdr_rfs_ustat,		(XDR *, rfs_ustat *));
EXTERN_FUNCTION( extern bool_t xdr_rfs_dirent,		(XDR *, rfs_dirent *));
EXTERN_FUNCTION( extern bool_t xdr_rfs_utimbuf,		(XDR *, rfs_utimbuf *));
EXTERN_FUNCTION( extern bool_t xdr_rfs_message,		(XDR *, struct message *));
EXTERN_FUNCTION( extern bool_t xdr_rfs_common,		(XDR *, struct common *));
EXTERN_FUNCTION( extern bool_t xdr_rfs_request,		(XDR *, struct request *));

EXTERN_FUNCTION( extern u_int xdrwrap_rfs_flock,	(char *, char *,enum xdr_op));
EXTERN_FUNCTION( extern u_int xdrwrap_rfs_stat,		(char *, char *,enum xdr_op));
EXTERN_FUNCTION( extern u_int xdrwrap_rfs_statfs,	(char *, char *,enum xdr_op));
EXTERN_FUNCTION( extern u_int xdrwrap_rfs_ustat,	(char *, char *,enum xdr_op));
EXTERN_FUNCTION( extern u_int xdrwrap_rfs_dirent,	(char *, char *,enum xdr_op));
EXTERN_FUNCTION( extern u_int xdrwrap_rfs_utimbuf,	(char *, char *,enum xdr_op));
EXTERN_FUNCTION( extern u_int xdrwrap_rfs_message,	(char *, char *,enum xdr_op));
EXTERN_FUNCTION( extern u_int xdrwrap_rfs_request,	(char *, char *,enum xdr_op));
EXTERN_FUNCTION( extern u_int xdrwrap_rfs_string,	(char *, char *,enum xdr_op));

#endif /*!_rfs_rfs_xdr_h*/
