/*	@(#)pmap_clnt.h 1.13 89/07/26 SMI	*/

/*
 * pmap_clnt.h
 * Supplies C routines to get to portmap services.
 *
 * Copyright (C) 1984, Sun Microsystems, Inc.
 */

/*
 * Usage:
 *	success = pmap_set(program, version, protocol, port);
 *	success = pmap_unset(program, version);
 *	port = pmap_getport(address, program, version, protocol);
 *	head = pmap_getmaps(address);
 *	clnt_stat = pmap_rmtcall(address, program, version, procedure,
 *		xdrargs, argsp, xdrres, resp, tout, port_ptr)
 *		(works for udp only.)
 * 	clnt_stat = clnt_broadcast(program, version, procedure,
 *		xdrargs, argsp,	xdrres, resp, eachresult)
 *		(like pmap_rmtcall, except the call is broadcasted to all
 *		locally connected nets.  For each valid response received,
 *		the procedure eachresult is called.  Its form is:
 *	done = eachresult(resp, raddr)
 *		bool_t done;
 *		caddr_t resp;
 *		struct sockaddr_in raddr;
 *		where resp points to the results of the call and raddr is the
 *		address if the responder to the broadcast.
 */

#ifndef _rpc_pmap_clnt_h
#define	_rpc_pmap_clnt_h

#include <c_varieties.h>
#include <rpc/types.h>
#include <netinet/in.h>

EXTERN_FUNCTION( extern bool_t		pmap_set,	(u_long, u_long, int, u_short));
EXTERN_FUNCTION( extern bool_t		pmap_unset,	(u_long, u_long));
EXTERN_FUNCTION( extern struct pmaplist	*pmap_getmaps,	(struct sockaddr_in *));
EXTERN_FUNCTION( enum clnt_stat		pmap_rmtcall,
			(struct sockaddr_in *, u_long, u_long, u_long,
			xdrproc_t, caddr_t, xdrproc_t, caddr_t,
			struct timeval, u_long *));

#if defined (c_plusplus) || defined (__cplusplus) || defined (__STDC__)
    typedef bool_t (*resultproc_t)(char *, struct in_addr *);
#else
    typedef bool_t (*resultproc_t)();
#endif

EXTERN_FUNCTION( enum clnt_stat		clnt_broadcast, 
		(u_long, u_long, u_long, xdrproc_t, 
		caddr_t, xdrproc_t, caddr_t, 
		resultproc_t));
EXTERN_FUNCTION( extern u_short		pmap_getport,
        (struct sockaddr_in *, u_long, u_long, u_int));

#endif /*!_rpc_pmap_clnt_h*/
