/*	@(#)rstat.h 1.13 89/03/07 SMI */

/*
 * Copyright (c) 1984 by Sun Microsystems, Inc.
 */

#ifndef _rpcsvc_rstat_h
#define _rpcsvc_rstat_h

#ifndef CPUSTATES
#include <sys/dk.h>
#endif

#include <rpc/types.h>

#include <c_varieties.h>

struct stats {				/* version 1 */
	int cp_time[4];
	int dk_xfer[4];
	u_int v_pgpgin;		/* these are cumulative sum */
	u_int v_pgpgout;
	u_int v_pswpin;
	u_int v_pswpout;
	u_int v_intr;
	int if_ipackets;
	int if_ierrors;
	int if_opackets;
	int if_oerrors;
	int if_collisions;
};
typedef struct stats stats;
EXTERN_FUNCTION( bool_t xdr_stats,	(XDR *, struct stats *));

struct statsswtch {				/* version 2 */
	int cp_time[4];
	int dk_xfer[4];
	u_int v_pgpgin;
	u_int v_pgpgout;
	u_int v_pswpin;
	u_int v_pswpout;
	u_int v_intr;
	int if_ipackets;
	int if_ierrors;
	int if_opackets;
	int if_oerrors;
	int if_collisions;
	u_int v_swtch;
	long avenrun[3];
	struct timeval boottime;
};
typedef struct statsswtch statsswtch;
EXTERN_FUNCTION( bool_t xdr_statsswtch,	(XDR *, struct statsswtch *));

struct statstime {				/* version 3 */
	int cp_time[4];
	int dk_xfer[4];
	u_int v_pgpgin;
	u_int v_pgpgout;
	u_int v_pswpin;
	u_int v_pswpout;
	u_int v_intr;
	int if_ipackets;
	int if_ierrors;
	int if_opackets;
	int if_oerrors;
	int if_collisions;
	u_int v_swtch;
	long avenrun[3];
	struct timeval boottime;
	struct timeval curtime;
};
typedef struct statstime statstime;
EXTERN_FUNCTION( bool_t xdr_statstime,	(XDR *,  statstime *));

struct statsvar {				/* version 4 */
	struct {
		u_int cp_time_len;
		int *cp_time_val;
	} cp_time;			/* variable sized */
	struct {
		u_int dk_xfer_len;
		int *dk_xfer_val;
	} dk_xfer;			/* variable sized */
	u_int v_pgpgin;
	u_int v_pgpgout;
	u_int v_pswpin;
	u_int v_pswpout;
	u_int v_intr;
	int if_ipackets;
	int if_ierrors;
	int if_opackets;
	int if_oerrors;
	int if_collisions;
	u_int v_swtch;
	long avenrun[3];
	struct timeval boottime;
	struct timeval curtime;
};
typedef struct statsvar statsvar;
EXTERN_FUNCTION( bool_t xdr_statsvar,	(XDR *, statsvar *));

#define RSTATPROG ((u_long)100001)
#define RSTATVERS_SWTCH ((u_long)2)
#define RSTATPROC_STATS ((u_long)1)
EXTERN_FUNCTION( extern statsswtch *rstatproc_stats_2,	(void *,CLIENT *));
#define RSTATPROC_HAVEDISK ((u_long)2)
EXTERN_FUNCTION( extern long *rstatproc_havedisk_2,	(void *,CLIENT *));
#define RSTATVERS_TIME ((u_long)3)
EXTERN_FUNCTION( extern statstime *rstatproc_stats_3,	(void *,CLIENT *));
EXTERN_FUNCTION( extern long *rstatproc_havedisk_3,	(void *,CLIENT *));
#define RSTATVERS_VAR ((u_long)4)
EXTERN_FUNCTION( extern statsvar *rstatproc_stats_4,	(void *,CLIENT *));
EXTERN_FUNCTION( extern long *rstatproc_havedisk_4,	(void *,CLIENT *));
EXTERN_FUNCTION( int havedisk,	(char*));
EXTERN_FUNCTION( extern int rstat,	(char*, struct statstime*));

#endif /*!_rpcsvc_rstat_h*/
