/*    @(#)ypclnt.h 1.14 90/01/03 Copyr 1990 Sun Microsystems, Inc
  */

/*
 * ypclnt.h
 * This defines the symbols used in the c language
 * interface to the NIS client functions.  A description of this interface
 * can be read in ypclnt(3N).
 */

/*
 * Failure reason codes.  The success condition is indicated by a functional
 * value of "0".
 */
#define YPERR_BADARGS 1			/* Args to function are bad */
#define YPERR_RPC 2			/* RPC failure */
#define YPERR_DOMAIN 3			/* Can't bind to a server which serves
					 *   this domain. */
#define YPERR_MAP 4			/* No such map in server's domain */
#define YPERR_KEY 5			/* No such key in map */
#define YPERR_YPERR 6			/* Internal NIS server or client
					 *   interface error */
#define YPERR_RESRC 7			/* Local resource allocation failure */
#define YPERR_NOMORE 8			/* No more records in map database */
#define YPERR_PMAP 9			/* Can't communicate with portmapper */
#define YPERR_YPBIND 10			/* Can't communicate with ypbind */
#define YPERR_YPSERV 11			/* Can't communicate with ypserv */
#define YPERR_NODOM 12			/* Local domain name not set */
#define YPERR_BADDB 13			/* NIS data base is bad */
#define YPERR_VERS 14			/* NIS version mismatch */
#define YPERR_ACCESS 15			/* Access violation */
#define YPERR_BUSY 16			/* Database is busy */

/*
 * Types of update operations
 */
#define YPOP_CHANGE 1			/* change, do not add */
#define YPOP_INSERT 2			/* add, do not change */
#define YPOP_DELETE 3			/* delete this entry */
#define YPOP_STORE  4			/* add, or change */
 
#include <c_varieties.h>
 

/*           
 * Data definitions
 */

/*
 * struct ypall_callback * is the arg which must be passed to yp_all
 */

struct ypall_callback {
	int (*foreach)(DOTDOTDOT);		/* Return non-0 to stop getting
					 *  called */
	char *data;			/* Opaque pointer for use of callback
					 *   function */
};

/*
 * External NIS client function references. 
 */
EXTERN_FUNCTION( extern int yp_bind,			(char *));
EXTERN_FUNCTION( extern int _yp_dobind,			(char *,struct dom_binding **));
EXTERN_FUNCTION( extern void yp_unbind,			(char *));
EXTERN_FUNCTION( extern int yp_get_default_domain,	(char **));
EXTERN_FUNCTION( extern int yp_match ,			(char *,char *,char *,int,
							 char **,int *));
EXTERN_FUNCTION( extern int yp_first,			(char *,char *,char **,
							 int *,char *,int*));
EXTERN_FUNCTION( extern int yp_next,			(char *,char *,char *,int,
							 char **,int *,char **,int*));
EXTERN_FUNCTION( extern int yp_master,			(char *,char *,char **));
EXTERN_FUNCTION( extern int yp_order,			(char *,char *,unsigned long *));
EXTERN_FUNCTION( extern int yp_all,			(char *,char *,struct ypall_callback *));
EXTERN_FUNCTION( extern char *yperr_string,		(int));
EXTERN_FUNCTION( extern int ypprot_err,			(unsigned int));

/*
 * Global NIS data structures
 */
