/*      @(#)stdio.h 1.16 89/12/29 SMI; from UCB 1.4 06/30/83    */

# ifndef FILE
#include <c_varieties.h>

#define BUFSIZ  1024
#define _SBFSIZ 8
extern  struct  _iobuf {
        int     _cnt;
        unsigned char *_ptr;
        unsigned char *_base;
        int     _bufsiz;
        short   _flag;
        char    _file;          /* should be short */
} _iob[];

#define _IOFBF  0
#define _IOREAD 01
#define _IOWRT  02
#define _IONBF  04
#define _IOMYBUF        010
#define _IOEOF  020
#define _IOERR  040
#define _IOSTRG 0100
#define _IOLBF  0200
#define _IORW   0400
#define NULL    0
#define FILE    struct _iobuf
#define EOF     (-1)

#define stdin   (&_iob[0])
#define stdout  (&_iob[1])
#define stderr  (&_iob[2])

#ifdef lint	/* so that lint likes (void)putc(a,b) */
EXTERN_FUNCTION ( extern int putc,	(char, FILE *) );
EXTERN_FUNCTION ( extern int getc,	(FILE *) );
#else
EXTERN_FUNCTION ( extern int _flsbuf,	(unsigned char, FILE *) );
EXTERN_FUNCTION ( extern int _filbuf,	(FILE *) );

#define getc(p)         (--(p)->_cnt>=0? ((int)*(p)->_ptr++):_filbuf(p))
#define putc(x, p)      (--(p)->_cnt >= 0 ?\
        (int)(*(p)->_ptr++ = (unsigned char)(x)) :\
        (((p)->_flag & _IOLBF) && -(p)->_cnt < (p)->_bufsiz ?\
                ((*(p)->_ptr = (unsigned char)(x)) != '\n' ?\
                        (int)(*(p)->_ptr++) :\
                        _flsbuf(*(unsigned char *)(p)->_ptr, p)) :\
                _flsbuf((unsigned char)(x), p)))
#endif
#define	getchar()	getc(stdin)
#define	putchar(x)	putc((x),stdout)
#define	feof(p)		(((p)->_flag&_IOEOF)!=0)
#define	ferror(p)	(((p)->_flag&_IOERR)!=0)
#define	fileno(p)	((p)->_file)
#define	clearerr(p)	(void) ((p)->_flag &= ~(_IOERR|_IOEOF))

EXTERN_FUNCTION ( extern FILE	*fopen,		(const char *, const char *) );
EXTERN_FUNCTION ( extern FILE	*fdopen,	(int, const char *) );
EXTERN_FUNCTION ( extern FILE	*freopen,	(const char *, const char *, FILE *) );
EXTERN_FUNCTION ( extern FILE	*popen,		(const char *, const char *) );
EXTERN_FUNCTION ( extern FILE	*tmpfile,	(_VOID_) );
EXTERN_FUNCTION ( extern long	ftell,		(FILE *) );
EXTERN_FUNCTION ( extern char	*fgets,		(char *, int, FILE *) );
EXTERN_FUNCTION ( extern char	*gets,		(char *) );
EXTERN_FUNCTION ( extern void    exit,		(int) );
EXTERN_FUNCTION ( extern char	*sprintf,	(char *, const char *, DOTDOTDOT) );		
/*
 *  Additional declarations to make C++ happy.
 */
EXTERN_FUNCTION ( extern int puts,	(const char*) );
EXTERN_FUNCTION ( extern int fputs,	(const char*, FILE*) );
EXTERN_FUNCTION ( extern int printf,	(const char*, DOTDOTDOT) );
EXTERN_FUNCTION ( extern int fprintf,	(FILE*, const char*, DOTDOTDOT) );
EXTERN_FUNCTION ( extern int scanf,	(const char*, DOTDOTDOT) );
EXTERN_FUNCTION ( extern int fscanf,	(FILE*, const char*, DOTDOTDOT) );
EXTERN_FUNCTION ( extern int sscanf,	(char*, const char*, DOTDOTDOT) );
EXTERN_FUNCTION ( extern int fread,	(char*, unsigned int, int, FILE*) );
EXTERN_FUNCTION ( extern int fwrite,	(const char*, unsigned int, int, FILE*) );
EXTERN_FUNCTION ( extern int fclose,	(FILE*) );
EXTERN_FUNCTION ( extern int fflush,	(FILE*) );
EXTERN_FUNCTION ( extern int fseek,	(FILE*, long, int) );
EXTERN_FUNCTION ( extern void rewind,	(FILE*) );
EXTERN_FUNCTION ( extern int getw,	(FILE*) );
EXTERN_FUNCTION ( extern int fgetc,	(FILE*) );

EXTERN_FUNCTION ( extern int pclose,	(FILE*) );
EXTERN_FUNCTION ( extern int putw,	(int, FILE*) );
EXTERN_FUNCTION ( extern int fputc,	(char, FILE*) );
EXTERN_FUNCTION ( extern void setbuf,	(FILE*, char*) );
EXTERN_FUNCTION ( extern void setbuffer, (FILE*, char*, int));
EXTERN_FUNCTION ( extern void setlinebuf, (FILE*));
EXTERN_FUNCTION ( extern int ungetc,	(int, FILE*) );

EXTERN_FUNCTION ( extern int abort,	(_VOID_) );
EXTERN_FUNCTION ( extern long strtol,	(const char *, char **, int) );
EXTERN_FUNCTION ( extern double strtod,	(const char *, char **) );
EXTERN_FUNCTION ( extern int atoi,	(const char*) );
EXTERN_FUNCTION ( extern double atof,	(const char*) );
EXTERN_FUNCTION ( extern long atol,	(const char*) );
EXTERN_FUNCTION ( extern void perror,	(const char*) );

EXTERN_FUNCTION ( extern char	*ctermid,	(char *) );
EXTERN_FUNCTION ( extern char	*cuserid,	(char *) );
EXTERN_FUNCTION ( extern char	*tempnam,	(const char *, const char *) );
EXTERN_FUNCTION ( extern char	*tmpnam,	(char *) );
EXTERN_FUNCTION ( extern void    psignal,	(unsigned, char*));
EXTERN_FUNCTION ( extern int	 putenv,	(const char*));
EXTERN_FUNCTION ( extern void	 setusershell,	(_VOID_));
EXTERN_FUNCTION ( extern char 	*setstate,	(char*));
EXTERN_FUNCTION ( extern void    srandom,	(unsigned));
EXTERN_FUNCTION ( extern long	 random,	(_VOID_));
EXTERN_FUNCTION ( extern void	 swab,		(const char*, char*, int));
EXTERN_FUNCTION ( extern char   *getpass,	(const char*));


#define L_ctermid	9
#define L_cuserid	9
#define P_tmpdir	"/usr/tmp/"
#define L_tmpnam        25              /* (sizeof(P_tmpdir) + 15) */

/* 
 * system error messages - additional decls to please C++.
 */
extern int errno;
extern char* sys_errlist[];
extern int sys_nerr;

# endif
