/* Sun @(#)stdlib.h 1.30 90/08/09 SMI */
/*	@(#)stdlib.h 1.2 89/10/10 SMI; from include/stdlib.h 1.6;
 *	from AT&T "@(#)C++env:incl-master/proto-headers/stdlib.h  1.8"
 */

/*
 * stdlib.h
 */

#ifndef	__stdlib_h
#define	__stdlib_h

#include <c_varieties.h>
#include <stddef.h>
#include <pwd.h>
#include <errno.h>
#include <sys/types.h>		/* to get u_short */
#include <sys/stdtypes.h>	/* to get size_t */
#include <malloc.h>

/* All functions defined in <regcmp.h>, <rand48.h> are defined below already:
 *
 *  #include <regcmp.h>
 *  #include <rand48.h>
 *
 */


extern unsigned int _mb_cur_max;
#define MB_CUR_MAX    _mb_cur_max

#define	mblen(s, n)	mbtowc((wchar_t *)0, s, n)

extern 	char *optarg;
extern 	int  optind, opterr;
extern	char **environ;
extern	int end, etext, edata;

/* declaration of various libc functions */
EXTERN_FUNCTION(extern  void	l3tol,		(long*, const char*, int));
EXTERN_FUNCTION(extern 	long 	a64l,		(const char*));
EXTERN_FUNCTION(extern  int	abort,		( _VOID_ ));
EXTERN_FUNCTION(extern  int	abs,		(int));
EXTERN_FUNCTION(extern unsigned alarm,        	(unsigned) );
EXTERN_FUNCTION(extern  double	atof,		(const char*));
EXTERN_FUNCTION(extern  int	atoi,		(const char*));
EXTERN_FUNCTION(extern 	long 	atol,		(const char*));
EXTERN_FUNCTION(extern  int 	bcmp,     	(const void*, const void*,int) );
EXTERN_FUNCTION(extern  void 	bcopy,    	(const void*, void*, int) );
EXTERN_FUNCTION(extern  char*	bsearch,	(const char*, char*, unsigned , int , int (*)(const void*, const void*)));
EXTERN_FUNCTION(extern  void 	bzero,    	(void*, int));
EXTERN_FUNCTION(extern  char*	calloc,		(size_t , size_t));
EXTERN_FUNCTION(extern 	long 	clock,    	(_VOID_));
EXTERN_FUNCTION(extern 	void 	closelog,     	(_VOID_));
EXTERN_FUNCTION(extern  char*	_crypt,		(char*, char*));
EXTERN_FUNCTION(extern  char*	crypt,		(const char*, const char*));
EXTERN_FUNCTION(extern  char* 	ctermid, 	(char*));
EXTERN_FUNCTION(extern  char* 	cuserid, 	(char*));
EXTERN_FUNCTION(extern 	double 	drand48,     	(_VOID_));
EXTERN_FUNCTION(extern  char*	ecvt,		(double, int, int*, int*));
EXTERN_FUNCTION(extern  void	encrypt,	(char*, int));
EXTERN_FUNCTION(extern  void	endac,		(_VOID_));
EXTERN_FUNCTION(extern 	void  	endnetgrent,   	(_VOID_));
EXTERN_FUNCTION(extern 	void	endusershell,	(_VOID_));
EXTERN_FUNCTION(extern 	double 	erand48,     	(unsigned short xsubi[3]) );
EXTERN_FUNCTION(extern  int 	execl,     	(const char*, const char *, DOTDOTDOT));
EXTERN_FUNCTION(extern  int 	execle,    	(const char*, const char*, DOTDOTDOT));
EXTERN_FUNCTION(extern  int 	execlp,    	(const char*, const char*, DOTDOTDOT));
EXTERN_FUNCTION(extern  int 	execv,     	(const char*, const char *[]));
EXTERN_FUNCTION(extern  int 	execvp,    	(const char*, const char *[]));
EXTERN_FUNCTION(extern  void	exit,		(int));
EXTERN_FUNCTION(extern  double 	fabs,		(double));
EXTERN_FUNCTION(extern  const char* 	fcvt,		(double, int, int*, int*));
EXTERN_FUNCTION(extern  int 	ffs,       	(int));
EXTERN_FUNCTION(extern  int	free,		(char*));
EXTERN_FUNCTION(extern  double 	frexp,		(double, int*));
EXTERN_FUNCTION(extern  char*	gcvt,         	(double, int, char*));
EXTERN_FUNCTION(extern  int	getacdir,	(char*, int));
EXTERN_FUNCTION(extern  int	getacflg,	(char*, int));
EXTERN_FUNCTION(extern  int	getacmin,	(int*));
EXTERN_FUNCTION(extern  char* 	getcwd,        	(char*, int) );
EXTERN_FUNCTION(extern  char*	getenv,		(const char*));
EXTERN_FUNCTION(extern  char* 	getlogin,     	(_VOID_));
EXTERN_FUNCTION(extern 	int   	getnetgrent,  	(char **, char **, char **));
EXTERN_FUNCTION(extern  int	getopt,		(int, const char* const*, const char*));
EXTERN_FUNCTION(extern  char* 	getpass,    	(const char*));
EXTERN_FUNCTION(extern  int 	getpw,		(int , char*));
EXTERN_FUNCTION(extern  int 	getsubopt,	(char **, char *[], char **));
EXTERN_FUNCTION(extern 	char* 	gettext,	(char*));
EXTERN_FUNCTION(extern 	char* 	textdomain,	(char*));
EXTERN_FUNCTION(extern 	char* 	getusershell,	(_VOID_));
EXTERN_FUNCTION(extern  char* 	getwd,		(char*));
EXTERN_FUNCTION(extern  int 	grpauth,	(char*, char*));
EXTERN_FUNCTION(extern 	int 	innetgr,	(char*, char*, char*, char*));
EXTERN_FUNCTION(extern 	char* 	initstate,	(unsigned, char*, int));
EXTERN_FUNCTION(extern  int 	initgroups,	(char*, int));
EXTERN_FUNCTION(extern 	int 	isatty, 	(int));
EXTERN_FUNCTION(extern 	int 	issecure,	(_VOID_));
EXTERN_FUNCTION(extern 	long   	jrand48,     	(unsigned short xsubi[3]));
EXTERN_FUNCTION(extern 	char*	l64a,		(long));
EXTERN_FUNCTION(extern 	void   	lcong48,     	(unsigned short param[7]));
EXTERN_FUNCTION(extern 	double 	ldexp,          (double, int));
EXTERN_FUNCTION(extern 	int 	lockf,    	(int, int, long));
EXTERN_FUNCTION(extern 	char*	logname,     	(_VOID_));
EXTERN_FUNCTION(extern 	void 	ltol3,		(char*, const long*,int));
EXTERN_FUNCTION(extern 	long   	lrand48,      	(_VOID_));
EXTERN_FUNCTION(extern  char*	malloc,		(size_t));
EXTERN_FUNCTION(extern 	size_t 	mbstowcs,	(wchar_t*, const char*, size_t));
EXTERN_FUNCTION(extern  int    	mbtowc,		(wchar_t*, const char*, size_t));
EXTERN_FUNCTION(extern 	int 	mkstemp,     	(char*));
EXTERN_FUNCTION(extern 	char* 	mktemp,     	(char*)); 
EXTERN_FUNCTION(extern 	double 	modf,           (double, double*));
EXTERN_FUNCTION(extern 	long   	mrand48,      	(_VOID_));
EXTERN_FUNCTION(extern 	int 	nice,     	(int));
EXTERN_FUNCTION(extern 	long   	nrand48,     	(unsigned short xsubi[3]));
EXTERN_FUNCTION(extern 	void 	openlog,      	(const char*, int, int));
EXTERN_FUNCTION(extern 	int	pause,     	(_VOID_));
EXTERN_FUNCTION(extern  void	perror,		(const char*));
EXTERN_FUNCTION(extern 	void 	psignal,        (unsigned, char*));
EXTERN_FUNCTION(extern 	int 	putenv,       	(const char*));
EXTERN_FUNCTION(extern 	int 	pwdauth,        (char*, char*));
EXTERN_FUNCTION(extern  void	qsort,		(void*, int, int, int (*)(const void*, const void*)));
EXTERN_FUNCTION(extern  int	rand,		(_VOID_));
EXTERN_FUNCTION(extern 	long 	random,      	(_VOID_));
EXTERN_FUNCTION ( extern int	rcmd,	(char**, u_short, char*, char*, char*, int*));
EXTERN_FUNCTION(extern  char*	realloc,	(char*, size_t));
EXTERN_FUNCTION(extern 	char*	realpath,     	(char*, char*));
EXTERN_FUNCTION(extern 	char*	re_comp,     	(const char*));
EXTERN_FUNCTION(extern 	int 	re_exec,        (const char*));
EXTERN_FUNCTION(extern 	int 	rnusers,     	(const char*));
EXTERN_FUNCTION(extern 	int 	rresvport,   	(int*));
EXTERN_FUNCTION(extern 	int 	ruserok,    	(const char*, int, const char*, const char*));
EXTERN_FUNCTION(extern 	int 	rwall,         	(const char*, const char*));
EXTERN_FUNCTION(extern 	unsigned short *seed48, (unsigned short seed16v[3]));
EXTERN_FUNCTION(extern  void	setac,		(_VOID_));
EXTERN_FUNCTION(extern 	int 	seteuid,      	(int));
EXTERN_FUNCTION(extern 	int 	setruid,        (int));
EXTERN_FUNCTION(extern 	int 	setgid,         (int));
EXTERN_FUNCTION(extern 	int 	setegid,        (int));
EXTERN_FUNCTION(extern 	int 	setrgid,        (int));
EXTERN_FUNCTION(extern  void	setkey,		(const char*));
EXTERN_FUNCTION(extern 	int 	setlogmask,   	(int));
EXTERN_FUNCTION(extern 	void  	setnetgrent,  	(char*));
EXTERN_FUNCTION(extern 	char*	setstate,   	(char*));
EXTERN_FUNCTION(extern 	int 	setuid,         (int));
EXTERN_FUNCTION(extern 	void    setusershell,  	(_VOID_));
EXTERN_FUNCTION(extern 	int 	siginterrupt,   (int, int));
EXTERN_FUNCTION(extern 	unsigned sleep,        	(unsigned));
EXTERN_FUNCTION(extern  void	srand,		(unsigned));
EXTERN_FUNCTION(extern 	void   	srand48,       	(long));
EXTERN_FUNCTION(extern 	void 	srandom,    	(unsigned));
EXTERN_FUNCTION(extern 	double 	strtod,       	(const char*, char**));
/*
EXTERN_FUNCTION(extern 	long 	strtoul,       	(const char*, char**, int));
*/
EXTERN_FUNCTION(extern 	long 	strtol,      	(const char*, char**, int));
EXTERN_FUNCTION(extern  void 	swab,         	(const char*, char*, int));
EXTERN_FUNCTION(extern  int 	system,      	(const char*));
EXTERN_FUNCTION(extern 	void 	syslog,     	(int, const char* ...));
EXTERN_FUNCTION(extern  char*	tempnam,      	(const char*, const char*));
EXTERN_FUNCTION(extern  time_t	time,		(time_t *));
EXTERN_FUNCTION(extern 	char*	timezone,       (int, int));
EXTERN_FUNCTION(extern  char*	tmpnam,     	(char*));
EXTERN_FUNCTION(extern  char* 	ttyname,      	(int));
EXTERN_FUNCTION(extern  int 	ttyslot,      	(_VOID_));
EXTERN_FUNCTION(extern 	unsigned ualarm,       	(unsigned, unsigned));
EXTERN_FUNCTION(extern 	long 	ulimit,         (int, long));
EXTERN_FUNCTION(extern 	void 	usleep,      	(unsigned));
EXTERN_FUNCTION(extern 	int    	wctomb,		(char*, wchar_t));
EXTERN_FUNCTION(extern 	size_t 	wcstombs,	(char*, const wchar_t*, size_t));

#endif
