/*	@(#)seg_kmem.h	1.17 89/08/31	SMI	*/

/*
 * Copyright (c) 1987 by Sun Microsystems, Inc.
 */

#ifndef _sun_seg_kmem_h
#define	_sun_seg_kmem_h
#include <c_varieties.h>


/*
 * VM - Kernel Segment Driver
 */

/*
 * These variables should be put in a place which
 * is guaranteed not to get paged out of memory.
 */
extern struct ctx *kctx;	/* kernel's context */
extern struct as kas;		/* kernel's address space */
extern struct seg kseg;		/* kernel's "most everything" segment */
extern struct seg kdvmaseg;	/* kernel's dvma segment */

/*
 * For segkmem_create, the argsp is actually a pointer to the
 * optional array of pte's used to map the given segment.
 */
EXTERN_FUNCTION ( extern int	segkmem_create,		(struct seg *, caddr_t));

/*
 * Special kernel segment operations. NOTE: mapin() and mapout() are
 * supported for compatibility only. Callers should be using
 * segkmem_mapin() and segkmem_mapout().
 */
EXTERN_FUNCTION( extern int	segkmem_alloc,		(struct seg *,addr_t,u_int,int,u_int));
EXTERN_FUNCTION( extern void	segkmem_free,		(struct seg *,addr_t,u_int));
EXTERN_FUNCTION( extern void	segkmem_mapin,		(struct seg *,addr_t,u_int,u_int,u_int,int));
EXTERN_FUNCTION( extern void	segkmem_mapout,		(struct seg *,addr_t,u_int));

/*
 * Usage codes.  The p_offset fields of page structs allocated through
 * segkmem_alloc() are set to one of these values to indicate what
 * the page is being used for.
 */
#define	SEGKMEM_HEAP	1
#define	SEGKMEM_STREAMS	2
#define	SEGKMEM_MBUF	3
#define	SEGKMEM_UFSBUF	4
#define	SEGKMEM_USTRUCT	5
#define	SEGKMEM_LOADMOD	6

#endif /*!_sun_seg_kmem_h*/
