/* @(#)help.h 1.5 88/11/15 SMI */

/*
 * Copyright (c) 1987 by Sun Microsystems, Inc. 
 */

#ifndef help_DEFINED
#define help_DEFINED

#include <c_varieties.h>
#include <sunwindow/attr.h>
#include <suntool/window.h>

#define HELPDIRECTORY "/usr/lib/help"
#define HELPINDEX "/usr/lib/help/helpindex"

/*
 * Attributes.
 */

#define HELP_ATTR(type, ordinal)	ATTR(ATTR_PKG_HELP, type, ordinal)

/* first attribute used */
#define HELP_FIRST_ATTR			32

typedef enum {
	HELP_DATA	= HELP_ATTR(ATTR_OPAQUE, HELP_FIRST_ATTR + 1),
} Help_attribute;

/* new attributes should start at HELP_LAST_ATTR + 1 */
#define HELP_LAST_ATTR			(HELP_FIRST_ATTR + 1)

#define event_is_help(event) (event_id(event)==ACTION_HELP)

/*
 * Public interface.
 */

EXTERN_FUNCTION ( extern void help_request,	(Window , caddr_t, Event *));
EXTERN_FUNCTION ( extern void help_more,	(Window, char*,Event *));
EXTERN_FUNCTION ( extern void help_set_request_func, (void    (*func)()));
EXTERN_FUNCTION ( extern void help_set_more_func,    (void    (*func)()));
EXTERN_FUNCTION ( extern char *help_get_arg,	(char *));
EXTERN_FUNCTION ( extern char *help_get_text, 	());

/*
 * Default help RPC interface.
 */

#define HELPREQUEST 1

#define HELPDEFAULTSERVER "help_viewer"
#define HELPDEFAULTPROG 100040
#define HELPVERS 1
#define HELPDATAMAX 512

typedef struct {
    char *data;		/* client data */
    int  x, y;		/* screen x, y */
    int  pid;		/* requesting process id */
    int  seq;		/* request sequence number */
} Help_request;

EXTERN_FUNCTION ( extern int xdr_help,		(XDR *, Help_request *));
				/* XDR routine for help args */
EXTERN_FUNCTION ( extern int help_rpc_register,	(void (*func)())); 
				/* register rpc handler with Notifier */

#endif not help_DEFINED


