/*	@(#)selection.h 10.4 88/02/08 SMI	*/

/*
 * Copyright (c) 1983 by Sun Microsystems, Inc.
 */

#include <c_varieties.h>
#include <sys/types.h>

struct	selection {
	int	sel_type,
		sel_items,
		sel_itembytes,
		sel_pubflags;
	caddr_t	sel_privdata;
};

extern	struct selection	selnull;

/*
 * sel_type values
 */
#define	SELTYPE_NULL	0
#define	SELTYPE_CHAR	1

/*
 * sel_itembytes values
 */
#define	SEL_UNKNOWNITEMS	-1	/* Don't know how many items */

/*
 * sel_pubflags values
 */
#define	SEL_PRIMARY	0X01	/* Primary selection */
#define	SEL_SECONDARY	0X02	/* Secondary selection */

/*
 * Create the selection
 */
EXTERN_FUNCTION(extern void	selection_set, (struct selection *sel, int (*sel_write)(), int (*sel_clear)(), int windowfd));
/*
 * Fetch the selection
 */
EXTERN_FUNCTION(extern void	selection_get, (int (*sel_read)(),int  windowfd));
/*
 * Clear the selection
 */
EXTERN_FUNCTION(extern void	selection_clear, (int windowfd));
/*
 * Write the bits of the selection
 */
EXTERN_FUNCTION(extern void	sel_write, (struct selection *sel, FILE *file));
/*
 * Read the bits of the selection
 */
EXTERN_FUNCTION(extern void	sel_read, (struct selection *sel, FILE *file));
/*
 * As the owner of the selection you should clear your hiliting because
 * you are no longer the selection owner.
 */
EXTERN_FUNCTION(extern void	sel_clear, (struct selection *sel, int windowfd));

