/*    @(#)hashfn.h 1.3 89/10/03 SMI   */

/*
 *    hashfn.h -- external declarations
 */

#ifndef hashfn_h
#define hashfn_h

#include <sys/types.h>
#ifndef C_VARIETIES_H
#include <c_varieties.h>
#endif

typedef struct he_ HashEntry;

struct he_ {
    HashEntry    *he_next;
    HashEntry    *he_prev;
    caddr_t        he_key;
    caddr_t        he_payload;
};

typedef struct ht_ HashTable;

struct ht_ {
    int            ht_size;
    
    /* hash func: int f(caddr_t) */
    int            (*ht_hash_fn)(DOTDOTDOT);

    /* compare func: int f(caddr_t, caddr_t) returns 0 for equal */
    int            (*ht_cmp_fn)(DOTDOTDOT);
    HashEntry    **ht_table;
};

#ifndef hashfn_c

EXTERN_FUNCTION ( extern HashTable *hashfn_new_table,	(int, int (*) (), int (*) ()) );
EXTERN_FUNCTION ( extern void hashfn_dispose_table,	(HashTable *) );

EXTERN_FUNCTION ( extern caddr_t /* payload pointer */ hashfn_lookup,	(HashTable *, caddr_t) );
EXTERN_FUNCTION ( extern caddr_t /* payload pointer */ hashfn_install,	(HashTable *, caddr_t, caddr_t) );
EXTERN_FUNCTION ( extern caddr_t /* payload pointer */ hashfn_delete,	(HashTable *, caddr_t) );

EXTERN_FUNCTION ( extern caddr_t /* key pointer */ hashfn_first_key,	(HashTable *, caddr_t *) );
EXTERN_FUNCTION ( extern caddr_t /* key pointer */ hashfn_next_key,	(HashTable *, caddr_t *) );

#endif hashfn_c
#endif hashfn_h
