/*	@(#)win_environ.h 10.4 88/02/08 SMI	*/

/*
 * Copyright (c) 1983 by Sun Microsystems, Inc.
 */

/*
 * The window library uses the ENVIRONMENT to pass a limited amount of
 * window information to newly created child processes.
 * A collection of conventions dictate the use of these values.
 */

#define	WE_PARENT		"WINDOW_PARENT"
#define	WE_INITIALDATA		"WINDOW_INITIALDATA"
#define	WE_GFX			"WINDOW_GFX"
#define	WE_ME			"WINDOW_ME"

#if defined(__cplusplus) || defined(c_plusplus) || defined(__STDC__)
#include <c_varieties.h>
/* Declare extern function prototypes */

/*
 * C Library routines specifically related to ENVIRONMENT conventions.
 */

/*
 * Get/set parent of window that is being created.
 */
EXTERN_FUNCTION(void	we_setparentwindow, (char *windevname) );
EXTERN_FUNCTION(int	we_getparentwindow, (char *windevname) );

/*
 * Get/set initial rect (parent relative) of window that is being created,
 * initial saved rect and whether or not iconic.
 * Values should be cleared so that no one mistakenly uses this data once the
 * information is used once.
 */
EXTERN_FUNCTION(void   we_setinitdata, (struct rect *init,
					struct rect *saved, int iconic) );
EXTERN_FUNCTION(int    we_getinitdata, (struct rect *init,
					struct rect *saved, int *iconic) );
EXTERN_FUNCTION(void   we_clearinitdata, (_VOID_) );

/*
 * Get/set window that can be taken over by graphics programs.
 */
EXTERN_FUNCTION(void	we_setgfxwindow, (char *windevname) );
EXTERN_FUNCTION(int	we_getgfxwindow, (char *windevname) );

/*
 * Get/set window that this process is currently running in.
 * Used by tty programs when they get a SIGWINCH so can readjust notion
 * of terminal size (see following comment).
 */
EXTERN_FUNCTION(void	we_setmywindow, (char *windevname) );
EXTERN_FUNCTION(int	we_getmywindow, (char *windevname) );

#endif
