/*	@(#)win_notify.h 10.5 88/02/08 SMI	*/

/*
 * Copyright (c) 1985 by Sun Microsystems, Inc.
 */

/*
 * SunWindows related notification definitions (see also notify.h).
 */

/* Flags for win_register call */
#define	PW_RETAIN	 0x1	/* Manage retained window (move to pixwin) */
#define	PW_FIXED_IMAGE	 0x2	/* Treat retained image as fixed size 
				   (move to pixwin) */
#define	PW_INPUT_DEFAULT 0x4	/* Input sink when cant be determined by x/y */
#define	PW_NO_LOC_ADJUST 0x8	/* Don't adjust x y to rgn coordinate space */
#define	PW_REPAINT_ALL	 0x10	/* Repaint entire pw on repaint */

#ifndef C_VARIETIES_H
#include <c_varieties.h>
#endif
/* Pixwin registration with SunWindows notification support routines */
EXTERN_FUNCTION(int	win_register,	(Notify_client, Pixwin *,
					 Notify_func event_func,
					 Notify_func destroy_func,
					 u_int flags) );
EXTERN_FUNCTION(int	win_unregister,	(Notify_client) );
EXTERN_FUNCTION(int	win_set_flags,	(Notify_client, u_int flags) );
EXTERN_FUNCTION(u_int	win_get_flags,	(Notify_client) );

/* Extraction of interesting values from window notifier clients */
EXTERN_FUNCTION(int	win_get_fd,	(Notify_client) );
EXTERN_FUNCTION(Pixwin *win_get_pixwin,	(Notify_client) );

/* Posting of client events to window notifier clients */
EXTERN_FUNCTION(Notify_error win_post_id, (Notify_client, short id,
					 Notify_event_type when) );
EXTERN_FUNCTION(Notify_error win_post_id_and_arg, (Notify_client, short id,
					 Notify_event_type when,
					 Notify_arg arg,
					 Notify_copy copy_func,
					 Notify_release release_func) );
EXTERN_FUNCTION(Notify_error win_post_event, (Notify_client, Event *,
					 Notify_event_type when) );
EXTERN_FUNCTION(Notify_error win_post_event_arg, (Notify_client, Event *,
					 Notify_event_type when,
					 Notify_arg arg,
					 Notify_copy copy_func,
					 Notify_release release_func) );

/* Utilities to call if posting with win_post_id_and_arg or win_post_event_arg*/
EXTERN_FUNCTION(Notify_arg win_copy_event, (Notify_client, Notify_arg,
					 Event **event_ptr) );
EXTERN_FUNCTION(void	win_free_event, (Notify_client, Notify_arg, Event *) );
