/*	@(#)resource.h 2.7 88/03/10 SMI; from UCB 4.1 83/02/10	*/

#ifndef	_sys_resource_h
#define	_sys_resource_h

#include <c_varieties.h>

/*
 * Process priority specifications to get/setpriority.
 */
#define	PRIO_MIN	-20
#define	PRIO_MAX	20

#define	PRIO_PROCESS	0
#define	PRIO_PGRP	1
#define	PRIO_USER	2

/*
 * Resource utilization information.
 */

#define	RUSAGE_SELF	0
#define	RUSAGE_CHILDREN	-1

struct	rusage {
	struct timeval ru_utime;	/* user time used */
	struct timeval ru_stime;	/* system time used */
	long	ru_maxrss;
#define	ru_first	ru_ixrss
	long    ru_ixrss;               /* XXX: 0 */
        long    ru_idrss;               /* XXX: sum of rm_asrss */
        long    ru_isrss;               /* XXX: 0 */
        long    ru_minflt;              /* any page faults not requiring I/O */
        long    ru_majflt;              /* any page faults requiring I/O */
	long	ru_nswap;		/* swaps */
	long	ru_inblock;		/* block input operations */
	long	ru_oublock;		/* block output operations */
	long	ru_msgsnd;		/* messages sent */
	long	ru_msgrcv;		/* messages received */
	long	ru_nsignals;		/* signals received */
	long	ru_nvcsw;		/* voluntary context switches */
	long	ru_nivcsw;		/* involuntary " */
#define	ru_last		ru_nivcsw
};

/*
 * Resource limits
 */
#define	RLIMIT_CPU	0		/* cpu time in milliseconds */
#define	RLIMIT_FSIZE	1		/* maximum file size */
#define	RLIMIT_DATA	2		/* data size */
#define	RLIMIT_STACK	3		/* stack size */
#define	RLIMIT_CORE	4		/* core file size */
#define	RLIMIT_RSS	5		/* resident set size */

#define RLIMIT_NOFILE   6               /* maximum descriptor index + 1 */

#define RLIM_NLIMITS    7               /* number of resource limits */

#define RLIM_INFINITY   0x7fffffff

struct rlimit {
	int	rlim_cur;		/* current (soft) limit */
	int	rlim_max;		/* maximum value for rlim_cur */
};

EXTERN_FUNCTION ( int getpriority,	(int, int) );
EXTERN_FUNCTION ( int setpriority,	(int, int, int) );
EXTERN_FUNCTION ( int getrlimit,	(int, struct rlimit*) );
EXTERN_FUNCTION ( int setrlimit,	(int, const struct rlimit*) );
EXTERN_FUNCTION ( int getrusage,	(int, struct rusage*) );

#endif	/*_sys_resource_h */
