/*	@(#)unistd.h 1.12 89/10/04 SMI; from S5R3 1.5 */

#ifndef	__sys_unistd_h
#define	__sys_unistd_h

#include <c_varieties.h>

/* WARNING: _SC_CLK_TCK and sysconf() are also defined/declared in <time.h>. */
#define	_SC_ARG_MAX		1	/* space for argv & envp */
#define	_SC_CHILD_MAX		2	/* maximum children per process??? */
#define	_SC_CLK_TCK		3	/* clock ticks/sec */
#define	_SC_NGROUPS_MAX		4	/* number of groups if multple supp. */
#define	_SC_OPEN_MAX		5	/* max open files per process */
#define	_SC_JOB_CONTROL		6	/* do we have job control */
#define	_SC_SAVED_IDS		7	/* do we have saved uid/gids */
#define	_SC_VERSION		8	/* POSIX version supported */

#define	_POSIX_JOB_CONTROL	1
#define	_POSIX_SAVED_IDS	1
#define	_POSIX_VERSION		198808

#define	_PC_LINK_MAX		1	/* max links to file/dir */
#define	_PC_MAX_CANON		2	/* max line length */
#define	_PC_MAX_INPUT		3	/* max "packet" to a tty device */
#define	_PC_NAME_MAX		4	/* max pathname component length */
#define	_PC_PATH_MAX		5	/* max pathname length */
#define	_PC_PIPE_BUF		6	/* size of a pipe */
#define	_PC_CHOWN_RESTRICTED	7	/* can we give away files */
#define	_PC_NO_TRUNC		8	/* trunc or error on >NAME_MAX */
#define	_PC_VDISABLE		9	/* best char to shut off tty c_cc */
#define	_PC_LAST		9	/* highest value of any _PC_* */

#define	STDIN_FILENO	0
#define	STDOUT_FILENO	1
#define	STDERR_FILENO	2

#ifndef NULL
#define	NULL	0
#endif

#ifndef	_POSIX_SOURCE
/*
 * SVID lockf() requests
 */
#define	F_ULOCK		0	/* Unlock a previously locked region */
#define	F_LOCK		1	/* Lock a region for exclusive use */
#define	F_TLOCK		2	/* Test and lock a region for exclusive use */
#define	F_TEST		3	/* Test a region for other processes locks */

/* Path names: */
#define	GF_PATH			"/etc/group"
#define	PF_PATH			"/etc/passwd"

#endif	!_POSIX_SOURCE

/*
 * lseek & access args
 *
 * SEEK_* have to track L_* in sys/file.h & SEEK_* in 5include/stdio.h
 * ?_OK have to track ?_OK in sys/file.h
 */
#ifndef SEEK_SET
#define	SEEK_SET	0	/* Set file pointer to "offset" */
#define	SEEK_CUR	1	/* Set file pointer to current plus "offset" */
#define	SEEK_END	2	/* Set file pointer to EOF plus "offset" */
#endif

#define	F_OK		0	/* does file exist */
#define	X_OK		1	/* is it executable by caller */
#define	W_OK		2	/* is it writable by caller */
#define	R_OK		4	/* is it readable by caller */

#if	!defined(KERNEL)
#include <sys/types.h>

EXTERN_FUNCTION( extern void	_exit,		( int ));
EXTERN_FUNCTION( extern int	access,		( const char *, int ));
EXTERN_FUNCTION( extern unsigned alarm,		( unsigned secs ));
EXTERN_FUNCTION( extern unsigned ualarm,	( unsigned, unsigned ));
EXTERN_FUNCTION( extern int	chdir,		( const char *));
EXTERN_FUNCTION( extern int	chmod,		( const char *, mode_t ));
EXTERN_FUNCTION( extern int	chown,		( const char *, uid_t , gid_t ));
EXTERN_FUNCTION( extern int	close,		( int ));
EXTERN_FUNCTION( extern char	*ctermid,	( char *));
EXTERN_FUNCTION( extern char	*cuserid,	( char *));
EXTERN_FUNCTION( extern int	dup,		( int ));
EXTERN_FUNCTION( extern int	dup2,		( int , int ));
EXTERN_FUNCTION( extern int	execl,		( const char *,const char *, DOTDOTDOT));
EXTERN_FUNCTION( extern int	execle,		( const char *,const char *, DOTDOTDOT));
EXTERN_FUNCTION( extern int	execlp,		( const char *,const char *, DOTDOTDOT));
EXTERN_FUNCTION( extern int	execv,		( const char *, const char *[]));
EXTERN_FUNCTION( extern int	execve,		( const char *, const char *[], char *[] ));
EXTERN_FUNCTION( extern int	execvp,		( const char *, const char *[] ));
EXTERN_FUNCTION( extern pid_t	fork,		( _VOID_));
EXTERN_FUNCTION( extern long	fpathconf,	( int , int ));
EXTERN_FUNCTION( extern char	*getcwd,	( char *, int ));
EXTERN_FUNCTION( extern gid_t	getegid,	( _VOID_));
EXTERN_FUNCTION( extern uid_t	geteuid,	( _VOID_));
EXTERN_FUNCTION( extern gid_t	getgid,		( _VOID_));
EXTERN_FUNCTION( extern int	getgroups,	( int , gid_t [] ));
EXTERN_FUNCTION( extern char	*getlogin,	( _VOID_));
EXTERN_FUNCTION( extern pid_t	getpgrp,	( DOTDOTDOT));
EXTERN_FUNCTION( extern pid_t	getpid,		( _VOID_));
EXTERN_FUNCTION( extern pid_t	getppid,	( _VOID_));
EXTERN_FUNCTION( extern uid_t	getuid,		( _VOID_));
EXTERN_FUNCTION( extern int	isatty,		( int ));
EXTERN_FUNCTION( extern int	link,		( const char *, const char *));
EXTERN_FUNCTION( extern off_t	lseek,		( int , off_t , int ));
EXTERN_FUNCTION( extern long	pathconf,	( char *, int ));
EXTERN_FUNCTION( extern int	pause,		( _VOID_)) ;
EXTERN_FUNCTION( extern int	pipe,		( int [] ));
EXTERN_FUNCTION( extern int	read,		( int , char *, int ));
EXTERN_FUNCTION( extern int	rmdir,		( const char *));
EXTERN_FUNCTION( extern int	setgid,		( int ));
EXTERN_FUNCTION( extern int	setpgid,	( pid_t , pid_t ));
EXTERN_FUNCTION( extern pid_t	setsid,		( _VOID_));
EXTERN_FUNCTION( extern int	setuid,		( int ));
EXTERN_FUNCTION( extern unsigned	sleep,	( unsigned int ));
EXTERN_FUNCTION( extern void	usleep,		( unsigned int ));
EXTERN_FUNCTION( extern long	sysconf,	( int ));
EXTERN_FUNCTION( extern pid_t	tcgetpgrp,	( int ));
EXTERN_FUNCTION( extern int	tcsetpgrp,	( int , pid_t ));
EXTERN_FUNCTION( extern char	*ttyname,	( int ));
EXTERN_FUNCTION( extern int	unlink,		( const char *));
EXTERN_FUNCTION( extern int	write,		( int , const char *, unsigned int ));

#endif	/* !KERNEL */
#endif	/* !__sys_unistd_h */
